org.apache.xpath.compiler

## Class FunctionTable

- java.lang.Object
- - org.apache.xpath.compiler.FunctionTable

-     public class FunctionTable
      extends java.lang.Object

  The function table for XPath.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `FUNC_BOOLEAN` The 'boolean()' id.
    `static int` | `FUNC_CEILING` The 'ceiling()' id.
    `static int` | `FUNC_CONCAT` The 'concat()' id.
    `static int` | `FUNC_CONTAINS` The 'contains()' id.
    `static int` | `FUNC_COUNT` The 'count()' id.
    `static int` | `FUNC_CURRENT` The 'current()' id.
    `static int` | `FUNC_DOCLOCATION` The 'document-location()' id (Proprietary).
    `static int` | `FUNC_EXT_ELEM_AVAILABLE` The 'element-available()' id (XSLT).
    `static int` | `FUNC_EXT_FUNCTION_AVAILABLE` The 'function-available()' id (XSLT).
    `static int` | `FUNC_FALSE` The 'false()' id.
    `static int` | `FUNC_FLOOR` The 'floor()' id.
    `static int` | `FUNC_GENERATE_ID` The 'generate-id()' id.
    `static int` | `FUNC_ID` The 'id()' id.
    `static int` | `FUNC_KEY` The 'key()' id (XSLT).
    `static int` | `FUNC_LANG` The 'lang()' id.
    `static int` | `FUNC_LAST` The 'last()' id.
    `static int` | `FUNC_LOCAL_PART` The 'local-name()' id.
    `static int` | `FUNC_NAMESPACE` The 'namespace-uri()' id.
    `static int` | `FUNC_NORMALIZE_SPACE` The 'normalize-space()' id.
    `static int` | `FUNC_NOT` The 'not()' id.
    `static int` | `FUNC_NUMBER` The 'number()' id.
    `static int` | `FUNC_POSITION` The 'position()' id.
    `static int` | `FUNC_QNAME` The 'name()' id.
    `static int` | `FUNC_ROUND` The 'round()' id.
    `static int` | `FUNC_STARTS_WITH` The 'starts-with()' id.
    `static int` | `FUNC_STRING` The 'string()' id.
    `static int` | `FUNC_STRING_LENGTH` The 'string-length()' id.
    `static int` | `FUNC_SUBSTRING` The 'substring()' id.
    `static int` | `FUNC_SUBSTRING_AFTER` The 'substring-after()' id.
    `static int` | `FUNC_SUBSTRING_BEFORE` The 'substring-before()' id.
    `static int` | `FUNC_SUM` The 'sum()' id.
    `static int` | `FUNC_SYSTEM_PROPERTY` The 'system-property()' id.
    `static int` | `FUNC_TRANSLATE` The 'translate()' id.
    `static int` | `FUNC_TRUE` The 'true()' id.
    `static int` | `FUNC_UNPARSED_ENTITY_URI` The 'unparsed-entity-uri()' id (XSLT).

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FunctionTable()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `functionAvailable(java.lang.String methName)` Tell if a built-in, non-namespaced function is available.
    `int` | `installFunction(java.lang.String name, java.lang.Class func)` Install a built-in function.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FUNC_CURRENT

          public static final int FUNC_CURRENT

      The 'current()' id.
      See Also:
        Constant Field Values

    - #### FUNC_LAST

          public static final int FUNC_LAST

      The 'last()' id.
      See Also:
        Constant Field Values

    - #### FUNC_POSITION

          public static final int FUNC_POSITION

      The 'position()' id.
      See Also:
        Constant Field Values

    - #### FUNC_COUNT

          public static final int FUNC_COUNT

      The 'count()' id.
      See Also:
        Constant Field Values

    - #### FUNC_ID

          public static final int FUNC_ID

      The 'id()' id.
      See Also:
        Constant Field Values

    - #### FUNC_KEY

          public static final int FUNC_KEY

      The 'key()' id (XSLT).
      See Also:
        Constant Field Values

    - #### FUNC_LOCAL_PART

          public static final int FUNC_LOCAL_PART

      The 'local-name()' id.
      See Also:
        Constant Field Values

    - #### FUNC_NAMESPACE

          public static final int FUNC_NAMESPACE

      The 'namespace-uri()' id.
      See Also:
        Constant Field Values

    - #### FUNC_QNAME

          public static final int FUNC_QNAME

      The 'name()' id.
      See Also:
        Constant Field Values

    - #### FUNC_GENERATE_ID

          public static final int FUNC_GENERATE_ID

      The 'generate-id()' id.
      See Also:
        Constant Field Values

    - #### FUNC_NOT

          public static final int FUNC_NOT

      The 'not()' id.
      See Also:
        Constant Field Values

    - #### FUNC_TRUE

          public static final int FUNC_TRUE

      The 'true()' id.
      See Also:
        Constant Field Values

    - #### FUNC_FALSE

          public static final int FUNC_FALSE

      The 'false()' id.
      See Also:
        Constant Field Values

    - #### FUNC_BOOLEAN

          public static final int FUNC_BOOLEAN

      The 'boolean()' id.
      See Also:
        Constant Field Values

    - #### FUNC_NUMBER

          public static final int FUNC_NUMBER

      The 'number()' id.
      See Also:
        Constant Field Values

    - #### FUNC_FLOOR

          public static final int FUNC_FLOOR

      The 'floor()' id.
      See Also:
        Constant Field Values

    - #### FUNC_CEILING

          public static final int FUNC_CEILING

      The 'ceiling()' id.
      See Also:
        Constant Field Values

    - #### FUNC_ROUND

          public static final int FUNC_ROUND

      The 'round()' id.
      See Also:
        Constant Field Values

    - #### FUNC_SUM

          public static final int FUNC_SUM

      The 'sum()' id.
      See Also:
        Constant Field Values

    - #### FUNC_STRING

          public static final int FUNC_STRING

      The 'string()' id.
      See Also:
        Constant Field Values

    - #### FUNC_STARTS_WITH

          public static final int FUNC_STARTS_WITH

      The 'starts-with()' id.
      See Also:
        Constant Field Values

    - #### FUNC_CONTAINS

          public static final int FUNC_CONTAINS

      The 'contains()' id.
      See Also:
        Constant Field Values

    - #### FUNC_SUBSTRING_BEFORE

          public static final int FUNC_SUBSTRING_BEFORE

      The 'substring-before()' id.
      See Also:
        Constant Field Values

    - #### FUNC_SUBSTRING_AFTER

          public static final int FUNC_SUBSTRING_AFTER

      The 'substring-after()' id.
      See Also:
        Constant Field Values

    - #### FUNC_NORMALIZE_SPACE

          public static final int FUNC_NORMALIZE_SPACE

      The 'normalize-space()' id.
      See Also:
        Constant Field Values

    - #### FUNC_TRANSLATE

          public static final int FUNC_TRANSLATE

      The 'translate()' id.
      See Also:
        Constant Field Values

    - #### FUNC_CONCAT

          public static final int FUNC_CONCAT

      The 'concat()' id.
      See Also:
        Constant Field Values

    - #### FUNC_SUBSTRING

          public static final int FUNC_SUBSTRING

      The 'substring()' id.
      See Also:
        Constant Field Values

    - #### FUNC_STRING_LENGTH

          public static final int FUNC_STRING_LENGTH

      The 'string-length()' id.
      See Also:
        Constant Field Values

    - #### FUNC_SYSTEM_PROPERTY

          public static final int FUNC_SYSTEM_PROPERTY

      The 'system-property()' id.
      See Also:
        Constant Field Values

    - #### FUNC_LANG

          public static final int FUNC_LANG

      The 'lang()' id.
      See Also:
        Constant Field Values

    - #### FUNC_EXT_FUNCTION_AVAILABLE

          public static final int FUNC_EXT_FUNCTION_AVAILABLE

      The 'function-available()' id (XSLT).
      See Also:
        Constant Field Values

    - #### FUNC_EXT_ELEM_AVAILABLE

          public static final int FUNC_EXT_ELEM_AVAILABLE

      The 'element-available()' id (XSLT).
      See Also:
        Constant Field Values

    - #### FUNC_UNPARSED_ENTITY_URI

          public static final int FUNC_UNPARSED_ENTITY_URI

      The 'unparsed-entity-uri()' id (XSLT).
      See Also:
        Constant Field Values

    - #### FUNC_DOCLOCATION

          public static final int FUNC_DOCLOCATION

      The 'document-location()' id (Proprietary).
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FunctionTable

          public FunctionTable()

  - ### Method Detail

    - #### installFunction

          public int installFunction(java.lang.String name,
                                     java.lang.Class func)

      Install a built-in function.
      Parameters:
        `name` - The unqualified name of the function, must not be null
        `func` - A Implementation of an XPath Function object.
      Returns:
        the position of the function in the internal index.

    - #### functionAvailable

          public boolean functionAvailable(java.lang.String methName)

      Tell if a built-in, non-namespaced function is available.
      Parameters:
        `methName` - The local name of the function.
      Returns:
        True if the function can be executed.

Copyright © 2023 Apache XML Project. All Rights Reserved.